<?php
/**
*
* @package Spammer Dection
* @version $Id: bot_scout.php 1373 2009-02-12 08:55:19Z xhotshotx $
* @copyright (c) 2009 Michael Williams (mtotheikle) http://startrekguide.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
* Special thanks to Francis Lewis (Handyman) for some ideas on handling data with simple XML.
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (!class_exists('spammer_base'))
{
	// Script was not call correct, exit.
	exit;
}

class bot_scout extends spammer_base
{
	/**
	 * Site where we check spammer data.
	 *
	 */
	private static $site = 'http://botscout.com/test/?multi&format=xml&';

	/**
	 * Checks to see if any of the data returned contains a spammer.
	 *
	 * @return array language string of a faild validation.
	 */
	public static function check_spammer($user_data)
	{
		global $user, $config;

		if (!$config['bot_scout_enabled'])
		{
			// This section not enabled.
			return;
		}

		// Add API key to url if we have one.
		if (isset($config['bot_scout_api']) && $config['bot_scout_api'])
		{
			self::$site .= 'key=' . $config['bot_scout_api'] . '&';
		}

		// Set the data that we want to validate.
		self::set_data($user_data);

		// Load result into simple XML.
		parent::load_file(self::$site, parent::$validate);

		// Check to make sure site returned simplexml object, may not if limit is reached and we dont have a API key.
		if (!is_object(parent::$xml))
		{
			return;
		}

		foreach (parent::$xml as $type)
		{
			if ((string) $type->matched == 'Y')
			{
				// Find out what faild against the spammer database.
				switch ($type->attributes()->test)
				{
					case 'IP':
						parent::$error .= "\n\n" . sprintf($user->lang['IP_FAILED'], parent::$validate['name'], parent::$validate['ip'], parent::$spam_sites[2]['link'], $user->lang[parent::$spam_sites[2]['lang']]);
					break;

					case 'MAIL':
						parent::$error .= "\n\n" . sprintf($user->lang['EMAIL_FAILED'], parent::$validate['name'], parent::$validate['mail'], parent::$spam_sites[2]['link'], $user->lang[parent::$spam_sites[2]['lang']]);
					break;

					case 'NAME':
						parent::$error .= "\n\n" . sprintf($user->lang['USERNAME'], parent::$validate['name'], parent::$spam_sites[2]['link'], $user->lang[parent::$spam_sites[2]['lang']]);
					break;
				}
			}
		}
	}

	/**
	 * Checks registration data for a potential spammer.
	 *
	 * @param array $user_data
	 */
	private static function set_data($user_data)
	{
		global $user;

		parent::$validate = array(
			'mail'		=> $user_data['user_email'],
			'name'		=> $user_data['username'],
			'ip'		=> $user->ip,
		);
	}
}
?>