<?php
/**
*
* @package Spammer Dection
* @version $Id: stop_forum_spam.php 1336 2009-02-01 20:52:09Z xhotshotx $
* @copyright (c) 2009 Michael Williams (mtotheikle) http://startrekguide.com
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
* Special thanks to Francis Lewis (Handyman) for some ideas on handling data with simple XML.
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

if (!class_exists('spammer_base'))
{
	// Script was not call correct, exit.
	exit;	
}

class stop_forum_spam extends spammer_base
{
	/**
	 * Site where we check spammer data.
	 *
	 */
	const site = 'http://www.stopforumspam.com/api?';
	
	/**
	 * Checks to see if any of the data returned contains a spammer.
	 *
	 * @return array language string of a faild validation.
	 */
	public static function check_spammer($user_data)
	{
		global $user, $config;
		
		if (!$config['stop_forum_enabled'])
		{
			// Section not enabled.
			return;
		}
		
		// Set the data we want to validate.
		self::set_data($user_data);
		
		$key = 0;
		
		while (true)
		{
			if (!isset(parent::$xml->type[$key]))
			{
				break;
			}
			
			if ((string) self::$xml->appears[$key] == 'yes')
			{
				// Figure out what failed.
				switch ((string) self::$xml->type[$key])
				{
					case 'ip':
						parent::$error .= "\n\n" . sprintf($user->lang['IP_FAILED'], self::$validate['username'], self::$validate['ip'], parent::$spam_sites[3]['link'], $user->lang[parent::$spam_sites[3]['lang']]);
					break;
					
					case 'email':
						parent::$error .= "\n\n" . sprintf($user->lang['EMAIL_FAILED'], self::$validate['username'], self::$validate['email'], parent::$spam_sites[3]['link'], $user->lang[parent::$spam_sites[3]['lang']]);
					break;
					
					case 'username':
						parent::$error .= "\n\n" . sprintf($user->lang['USERNAME_FAILED'], self::$validate['username'], parent::$spam_sites[3]['link'], $user->lang[parent::$spam_sites[3]['lang']]);
					break;
				}		
			}
			$key++;
		}
	}
	
	/**
	 * Checks registration data for a potential spammer.
	 *
	 * @param array $user_data
	 */
	private static function set_data($user_data)
	{
		global $user;
				
		parent::$validate = array(
			'email'		=> $user_data['user_email'],
			'username'	=> $user_data['username'],
			'ip'		=> $user->ip,
		);
		
		// Load XML file into simple xml object.
		self::load_file(self::site, parent::$validate);
	}
}
?>