<?php
/**
*
* @author mtotheikle (Michael Williams) mtotheikle@gmail.com
* @package umil
* @version $Id insall_spammer_mod.php 1.0.0 B3 2009-01-22 02:28:21GMT mtotheikle $
* @copyright (c) 2009 Michael Williams
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('UMIL_AUTO', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

if (!file_exists($phpbb_root_path . 'umil/umil_auto.' . $phpEx))
{
	trigger_error('Please download the latest UMIL (Unified MOD Install Library) from: <a href="http://www.phpbb.com/mods/umil/">phpBB.com/mods/umil</a>', E_USER_ERROR);
}

// Config information for UMIL.
$mod_name = 'SPAMMER_MOD';
$version_config_name = 'spammer_detection_version';
$language_file = 'mods/spammers';

/*
* The array of versions and actions within each.
* You do not need to order it a specific way (it will be sorted automatically), however, you must enter every version, even if no actions are done for it.
*
* You may not use words for the versions (like Alpha, Beta, Etc).  Only X.X.X (replacing X with a number).
*/
$versions = array(
	'1.0.0 B1'	=> array(
		'module_add' => array(
			array('acp', 'ACP_CAT_DOT_MODS', 'ACP_SPAMMERS'),

			array('acp', 'ACP_SPAMMERS', array(
				'module_basename'		=> 'spammers',
				'module_mode'			=> 'settings',
				'module_auth'			=> '',
				'module_langname'		=> 'ACP_SPAMMER_SETTINGS'
			)),
		),

		'config_add'	=> array(
			array('bot_scout_enabled', 1),
			array('bot_scout_api', ''),
			array('stop_forum_enabled', 1),
			array('stop_forum_api', ''),
		),
	),
	'1.0.0 B2'	=> array(),
	'1.0.0 B3'	=> array(),
	'1.0.0 B4' 	=> array(
		'config_add'	=> array(
			array('spammer_notify_pm', 1),
			array('spammer_pm_group', 0),
			array('spammer_notify_post', 0),
			array('spammer_forum_id', 0),
			array('spammer_topic_title', ''),
			array('spammer_poster_id', 2),
		),
		'custom'		=> 'set_default_group',
	),
	'1.0.0 B5' 	=> array(
		'config_add'	=> array(
			array('spammer_detection_enable', 0),
		)
	),
);

// Include the UMIF Auto file and everything else will be handled automatically.
include($phpbb_root_path . 'umil/umil_auto.' . $phpEx);

function set_default_group($action, $version)
{
	global $db;

	if ($action == 'uninstall')
	{
		return;
	}

	// See if we can find the admin group. Can't assume the default administators id since users may change.
	$sql = 'SELECT group_id
		FROM ' . GROUPS_TABLE . '
		WHERE LOWER(group_name) ' . $db->sql_like_expression('admin' . $db->any_char);
	$result = $db->sql_query($sql);
	$group_id = $db->sql_fetchfield('group_id', $sql);
	$db->sql_freeresult($result);

	// Set the Admin group to recieve PMs
	if ($group_id)
	{
		set_config('spammer_pm_group', $group_id);
	}
}
?>